[PATCH] ERB::Util.url_encode should not escape unreserved characters

07/04/2012 05:03 PM - madeofcode (Mark Dodwell)

Status: Closed   

Priority: Normal   

Assignee: k0kubun (Takashi Kokubun)   

Target version: 2.6   

ruby -v: ruby 1.9.3p194 (2012-04-20 revision

35410) [x86_64-darwin11.4.2]

Backport: 2.2: WONTFIX, 2.3: WONTFIX, 2.4:

UNKNOWN

Description

ERB::Util.url_encode is escaping tilde (~) where it should not according to the RFC.

This fixes that behaviour so that it now correctly avoids escaping all unreserved characters as per RFC 3986, Section 2.3:

http://tools.ietf.org/html/rfc3986#section-2.3

Fwiw., this is also how the Perl implementation works:

http://search.cpan.org/dist/URI/URI/Escape.pm#DESCRIPTION

I opened this issue originally on Github, but I think it warrants further discussion, so re-opening here.

Associated revisions

Revision 53127c2410c29f7cc942a76baa7be97ba65aafda - 05/17/2017 11:58 AM - k0kubun (Takashi Kokubun)

erb.rb: Don't encode tilde in #url_encode

Based on patch by madeofcode (Mark Dodwell).

[ruby-core:46168] [Bug #6696] [Fix GH-54]

~ is a unreserved character.

https://tools.ietf.org/html/rfc3986#section-2.3

git-svn-id: svn+ssh://ci.ruby-lang.org/ruby/trunk@58772 b2dd03c8-39d4-4d8f-98ff-823fe69b080e

Revision 53127c24 - 05/17/2017 11:58 AM - k0kubun (Takashi Kokubun)

erb.rb: Don't encode tilde in #url_encode

Based on patch by madeofcode (Mark Dodwell).

[ruby-core:46168] [Bug #6696] [Fix GH-54]

~ is a unreserved character.

https://tools.ietf.org/html/rfc3986#section-2.3

git-svn-id: svn+ssh://ci.ruby-lang.org/ruby/trunk@58772 b2dd03c8-39d4-4d8f-98ff-823fe69b080e

History

#1 - 07/04/2012 06:26 PM - madeofcode (Mark Dodwell)

Sorry, somehow this ticket subject line got truncated. Newline paste fail.

#2 - 07/04/2012 08:53 PM - shyouhei (Shyouhei Urabe)

- Subject changed from [PATCH]  to [PATCH] ERB::Util.url_encode should not escape unreserved characters

- Status changed from Open to Feedback

FYI, the old discussion is at https://github.com/ruby/ruby/pull/54

I see the patch itself is OK.  The question is to be or not to be able to escape tilde.

#3 - 07/05/2012 09:35 PM - naruse (Yui NARUSE)

- Status changed from Feedback to Assigned

- Assignee set to seki (Masatoshi Seki)
#4 - 07/06/2012 04:32 PM - duerst (Martin Dürst)

The tilde was added to the unreserved characters in URIs in RFC 2396. It is specifically mentioned in http://tools.ietf.org/html/rfc2396#appendix-G.2:

The tilde "~" character was added to those in the "unreserved" set,

since it is extensively used on the Internet in spite of the

difficulty to transcribe it with some keyboards.

RFC 2396 was published in August 1998, about 14 years ago. I think it's safe to make this change now :-).

#5 - 07/06/2012 04:58 PM - naruse (Yui NARUSE)

This can change but need not, so up to seki, the maintainer.

やってもやらなくてもいい変更だと思っているので、関さんにお任せします。

#6 - 02/26/2013 10:19 AM - naruse (Yui NARUSE)

- Target version changed from 1.9.3 to 2.6

#7 - 05/16/2017 01:22 AM - hsbt (Hiroshi SHIBATA)

- Assignee changed from seki (Masatoshi Seki) to k0kubun (Takashi Kokubun)

#8 - 05/17/2017 05:08 AM - duerst (Martin Dürst)

It's now close to 19 years since RFC 2396, so please fix this issue, thanks!

#9 - 05/17/2017 11:58 AM - k0kubun (Takashi Kokubun)

- Status changed from Assigned to Closed

Applied in changeset trunk|r58772.

erb.rb: Don't encode tilde in #url_encode

Based on patch by madeofcode (Mark Dodwell).

[ruby-core:46168] [Bug #6696] [Fix GH-54]

~ is a unreserved character.

https://tools.ietf.org/html/rfc3986#section-2.3

#10 - 06/29/2017 04:36 PM - usa (Usaku NAKAMURA)

- Backport changed from 2.2: UNKNOWN, 2.3: UNKNOWN, 2.4: UNKNOWN to 2.2: WONTFIX, 2.3: WONTFIX, 2.4: UNKNOWN

memo: I think that this is a bug, but it may surprise users to change this behavior at teeny releases.  Therefore I decided not to backport this to

ruby_2_3 branch.

Files

erb_util_url_encode_rfc_fix.patch 1.46 KB 07/04/2012 madeofcode (Mark Dodwell)
